<?php
/**
* @package: phpBB 3.0.8 :: 
* @version: $Id: index.php, v0.0.8 2011-08-26 11:08:26 leviatan21 Exp $
* @copyright: leviatan21 < info@mssti.com > (Gabriel) http://www.mssti.com/phpbb3/
* @license: http://opensource.org/licenses/gpl-license.php GNU Public License 
* @author: leviatan21 - http://www.phpbb.com/community/memberlist.php?mode=viewprofile&u=345763
**/

/**
* @ignore
**/

define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './../comunidad/';
$books_root_path = (defined('BOOKS_ROOT_PATH')) ? BOOKS_ROOT_PATH : './libros';
$script_name = (!empty($_SERVER['PHP_SELF'])) ? $_SERVER['PHP_SELF'] : getenv('PHP_SELF');
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup();

// Only registered users can go beyond this point
if (!$user->data['is_registered'])
{
	if ($user->data['is_bot'])
	{
		redirect(append_sid("{$phpbb_root_path}index.$phpEx"));
	}
	$user->add_lang('ucp');
	login_box('', $user->lang['LOGIN_EXPLAIN_UCP']);
}

$user->add_lang('search');

$submit = request_var('submit', false);
$search = request_var('search', false);
$keywords = utf8_normalize_nfc(request_var('keywords', '', true));
$search_terms = request_var('terms', 'all');
$start = max(request_var('start', 0), 0);

$filelist = $filelist_cats = array();
$book_rows = max(5, min(999, request_var('book_rows', 20)));
$match = array('.', '-', '_', '+', '#', '?', '/', '\\', '\'', '%', '&'," ");

$book_data = '';

// Are we searching ?
$sbook_category	= utf8_normalize_nfc(request_var('sbook_category', '', true));
$book_category	= utf8_normalize_nfc(request_var('book_category', $sbook_category, true));
$book_category	= ($book_category == '0') ? '' : $book_category;

// Are we searching ?
$sbook_chapter	= (!isset($_POST['update'])) ? '' : utf8_normalize_nfc(request_var('sbook_chapter', '', true));
$book_chapter	= (!isset($_POST['file'])) ? $sbook_chapter : utf8_normalize_nfc(request_var('book_chapter', $sbook_chapter, true));

// Grab file list of txt
$filelist = filelist($books_root_path, '', 'txt');

// Set a default categorie chapters
if (!$search && !$book_chapter && is_array($filelist))
{
	if (!empty($filelist[$book_category][0]))
	{
		$book_chapter = $filelist[$book_category][0];
	}
}

// make sure $book_file path doesn't go upwards
$book_file = str_replace('..', '.', $book_category) . str_replace('..', '.', $book_chapter);

// Now create the categories
$filelist_cats = create_categories($filelist);

// Check and display the book
if ($book_file)
{
	if (!file_exists("$books_root_path/$book_file") || !($book_data = @file_get_contents("$books_root_path/$book_file")))
	{
		meta_refresh(3, append_sid($phpbb_root_path . $script_name));
		$message = sprintf($user->lang['RETURN_INDEX'], '<a href="' . append_sid($phpbb_root_path . $script_name) . '">', '</a>');

		trigger_error($user->lang['FILE_NOT_FOUND'] . " <em>($book_file)</em>" . '<br /><br />' . $message);
	}
	// emulate the behavior of file()
	$book_rows = sizeof(explode("\n", $book_data));
}

$template->assign_vars(array(
	'S_BOOK'		=> true,
	// Generate list of categorised books
	'S_BOOKS'		=> generate_categories($filelist_cats, $book_category, $book_chapter, false),
	// Generate list of categorised chapters
	'S_CHAPTERS'	=> generate_categories($filelist_cats, $book_category, $book_chapter, true),
	'U_ACTION'		=> $script_name,
//	'BOOK_FILE'		=> $book_file,
	'BOOK_DATA'		=> utf8_htmlspecialchars($book_data),
	'BOOK_ROWS'		=> $book_rows,
	'BOOK_NOTE'		=> generate_note($books_root_path, $book_category, 'txt'),
	'S_SEARCH_ALL_TERMS'=> ($search_terms == 'all') ? true : false,
));

if (($submit || $search || $start) && $keywords)
{
	book_search($keywords, $start);
}

// Output page
page_header($user->lang['INDEX']);

$template->set_filenames(array(
	'body' => 'biblioteca/biblioteca_body.html')
);

page_footer();

// Now create the categories
function create_categories($filelist = array())
{
	$filelist_cats[''] = array();
	foreach ($filelist as $pathfile => $file_ary)
	{
		// Use the directory name as category name
		if (!empty($pathfile))
		{
			$filelist_cats[$pathfile] = array();
			foreach ($file_ary as $file)
			{
				$filelist_cats[$pathfile][$pathfile . $file] = $file;
			}
		}
		// or if it's in the main category use the word before the first underscore to group files
		else
		{
			$cats = array();
			foreach ($file_ary as $file)
			{
				$cats[] = substr($file, 0, strpos($file, '_'));
				$filelist_cats[substr($file, 0, strpos($file, '_'))][$file] = $file;
			}

			$cats = array_values(array_unique($cats));
			// we don't need any single element categories so put them into the misc '' category
			for ($i = 0, $n = sizeof($cats); $i < $n; $i++)
			{
				if (sizeof($filelist_cats[$cats[$i]]) == 1 && $cats[$i] !== '')
				{
					$filelist_cats[''][key($filelist_cats[$cats[$i]])] = current($filelist_cats[$cats[$i]]);
					unset($filelist_cats[$cats[$i]]);
				}
			}
			unset($cats);
		}
	}

	return $filelist_cats; 
}

// Generate list of categorised template files
function generate_categories($filelist_cats = array(), $selected_cat = '', $selected_file = '', $books = false)
{
	global $match;

	$tpl_options = '';
	ksort($filelist_cats);

	if (!is_array($selected_cat))
	{
		$selected_cat = array($selected_cat);
	}


	foreach ($filelist_cats as $category => $tpl_ary)
	{
		ksort($tpl_ary);

		if (empty($tpl_ary))
		{
			continue;
		}

		if (!$books)
		{
			if (!empty($category))
			{
				$selected = (in_array($category, $selected_cat)) ? ' selected="selected" ' : '';

				// We need to replace some stuff
				$clear_category = str_replace($match, ' ', $category);
				$tpl_options .= '<option class="sep' . (($selected) ? ' selected' : '') . '" value="' . $category . '"' . $selected . '>&nbsp;' . $clear_category . '&nbsp;</option>' . "\n";
			}
		}
		else
		{
			if (!in_array($category, $selected_cat))
			{
				continue;
			}
			foreach ($tpl_ary as $filename => $file)
			{
				$selected = ($file == $selected_file) ? ' selected="selected" class="selected" ' : '';

				// We need to replace some stuff
				$clear_file = str_replace($match, ' ', preg_replace('/\.txt$/i', "", $file));
				$tpl_options .= '<option value="' . $file . '"' . $selected . '>&nbsp;' . $clear_file . '&nbsp;</option>' . "\n";
			}
		}
	}
	return $tpl_options;
}

// Get physical file listing
function filelist($rootdir, $dir = '', $type = 'txt')
{
	$matches = array($dir => array());

	// Remove initial / if present
	$rootdir = (substr($rootdir, 0, 1) == '/') ? substr($rootdir, 1) : $rootdir;
	// Add closing / if not present
	$rootdir = ($rootdir && substr($rootdir, -1) != '/') ? $rootdir . '/' : $rootdir;

	// Remove initial / if present
	$dir = (substr($dir, 0, 1) == '/') ? substr($dir, 1) : $dir;
	// Add closing / if not present
	$dir = ($dir && substr($dir, -1) != '/') ? $dir . '/' : $dir;

	if (!is_dir($rootdir . $dir))
	{
		return $matches;
	}

	$dh = @opendir($rootdir . $dir);

	if (!$dh)
	{
		return $matches;
	}

	while (($fname = readdir($dh)) !== false)
	{
		if (is_file("$rootdir$dir$fname"))
		{
			if (filesize("$rootdir$dir$fname") && preg_match('#\.' . $type . '$#i', $fname) && !preg_match('#info\.' . $type . '$#i', $fname))
			{
				$matches[$dir][] = $fname;
			}
		}
		else if ($fname[0] != '.' && is_dir("$rootdir$dir$fname"))
		{
			$matches += filelist($rootdir, "$dir$fname", $type);
		}
	}
	closedir($dh);

	return $matches;
}

// 
function generate_note($rootdir, $dir = '', $type = 'txt')
{
	$info_txt = '';
	$matches = array($dir => array());

	// Remove initial / if present
	$rootdir = (substr($rootdir, 0, 1) == '/') ? substr($rootdir, 1) : $rootdir;
	// Add closing / if not present
	$rootdir = ($rootdir && substr($rootdir, -1) != '/') ? $rootdir . '/' : $rootdir;
	if (!is_dir($rootdir . $dir))
	{
		return $matches;
	}

	$dh = @opendir($rootdir . $dir);

	if (!$dh)
	{
		return $matches;
	}

	while (($fname = readdir($dh)) !== false)
	{
		if (is_file("$rootdir$dir$fname"))
		{
			if (filesize("$rootdir$dir$fname") && preg_match('#info\.' . $type . '$#i', $fname))
			{
				$matches[$dir][] = $fname;
			}
		}
	}
	closedir($dh);

	if (sizeof($matches[$dir]))
	{
		foreach ($matches as $pathfile => $file_ary)
		{
			// Use the directory name as category name
			if (!empty($pathfile))
			{
				$info_txt .= $pathfile;
				foreach ($file_ary as $file)
				{
					if (!empty($file))
					{
						$info_txt .= $file;
					}
				}
			}
		}

		if ($info_txt != '')
		{
			$book_data = @file_get_contents("$rootdir/$info_txt");
			$book_data = utf8_htmlspecialchars($book_data);
			$book_data = force_parse($book_data);
			return $book_data;
		}
	}
	return;
}

// 
function force_parse($text)
{
	global $phpbb_root_path, $phpEx;

	$message = utf8_normalize_nfc($text);
	$uid = $bitfield = $options = '';
	$allow_bbcode = $allow_urls = $allow_smilies = true;
	generate_text_for_storage($message, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);
	$text = generate_text_for_display($message, $uid, $bitfield, $options);
	return $text;
}

// 
function book_search($keywords, $start = 0)
{
	global $template, $user;
	global $config, $phpbb_root_path, $phpEx, $books_root_path, $script_name;

	// show_results should not change after this
	$total_match = 0;
	$total_match_count = 0;
	$per_page = $config['topics_per_page'];

	$search_terms	= request_var('terms', 'all');
	$keywords		= utf8_normalize_nfc(request_var('keywords', '', true));
	$add_keywords	= utf8_normalize_nfc(request_var('add_keywords', '', true));
	$book_category	= utf8_normalize_nfc(request_var('book_category', array('', ''), true));
//	$book_chapter	= utf8_normalize_nfc(request_var('book_chapter', array('',''), true));

	$key_words = $keywords;
	
	$search_class = search_book();
	$correct_query = $search_class->split_keywords_book($keywords, $search_terms);

	if (!$correct_query || empty($search_class->search_query))
	{
		$ignored = (sizeof($search_class->common_words)) ? sprintf($user->lang['IGNORED_TERMS_EXPLAIN'], implode(' ', $search_class->common_words)) . '<br />' : '';
		trigger_error($ignored . sprintf($user->lang['NO_KEYWORDS'], $search_class->word_length['min'], $search_class->word_length['max']));
	}
  
	$search = array();
	$filelist_cats[''] = array();

	// Grab file list of txt
	$filelist = filelist($books_root_path, '', 'txt');

	foreach ($filelist as $category => $cat_ary)
	{
		ksort($cat_ary);
		// If we have selected categories, only continue searchin on its
		if (!empty($book_category) && !in_array($category, $book_category))
		{
			continue;
		}
		// Don't waste time in emptyes categories
		if (empty($category))
		{
			continue;
		}

		foreach ($cat_ary as $filename => $book_file)
		{
			$book_data = @file_get_contents($books_root_path . '/' . $category . $book_file);
			$book_data = utf8_htmlspecialchars($book_data);

			$matches = $search_class->keyword_search_book($book_data, $book_file);
			if ($matches)
			{
				$filelist_cats[$category][$category . $book_file] = $book_file;
			}
		}
	}

	if (sizeof($filelist_cats))
	{
		foreach ($filelist_cats as $category => $tpl_ary)
		{
			ksort($tpl_ary);

			if (empty($tpl_ary))
			{
				continue;
			}

			foreach ($tpl_ary as $filename => $file)
			{
				$total_match_count++;

				// If we are in pagination
				if ($start)
				{
					// If the amount of books to display is lower than start, skip
					if ($total_match_count < ($start + 1))
					{
						continue;
					}
					// If the amount of books to display is bigger than per page, skip
					if ($total_match_count > ($start + $per_page))
					{
						continue;
					}
				}
				// If no pagination yet
				else
				{
					// If the amount of books to display is bigger than per page, skip
					if ($total_match_count > $per_page)
					{
						continue;
					}
				}

				$template->assign_block_vars('book_option', array(
					'BOOK_CATEGORY' => $category,
					'BOOK_CHAPTER' 	=> $file,
				));
				$total_match++;
			}
		}
	}

	$l_search_matches = ($total_match_count == 1) ? sprintf($user->lang['FOUND_SEARCH_MATCH'], $total_match_count) : sprintf($user->lang['FOUND_SEARCH_MATCHES'], $total_match_count);

	$u_search = append_sid($script_name, array('search' => true, 'keywords' => $key_words, 'terms' => $search_terms));

	$template->assign_vars(array(
		'S_BOOK'			=> false,
		'S_BOOK_SEARCH'		=> true,
		'PAGINATION'		=> generate_pagination($u_search, $total_match_count, $per_page, $start),
		'BOOK_PAGE_NUMBER'	=> on_page($total_match_count, $per_page, $start+1),
		'SEARCH_KEYWORDS'	=> $key_words,
		'SEARCH_KEYWORDS2'	=> $keywords,
		'S_SEARCH_ALL_TERMS'=> ($search_terms == 'all') ? true : false,
		'SEARCH_MATCHES'	=> $l_search_matches,
		'SEARCH_RESULTS'	=> $total_match_count,
		'U_ACTION'			=> $script_name,
		'S_SEARCH_ACTION'	=> $u_search,
	));

	// Output page
	page_header($user->lang['SEARCH']);

	$template->set_filenames(array(
		'body' => 'biblioteca/biblioteca_body.html')
	);

	page_footer();
}

function search_book()
{
	global $phpbb_root_path, $phpEx;

	// We do some additional checks in the module to ensure it can actually be utilised
//	include_once($phpbb_root_path . 'includes/search/search.' . $phpEx);
	include_once($phpbb_root_path . 'includes/search/fulltext_native.' . $phpEx);
	include_once('booksearch.' . $phpEx);

	$error = false;
	$search_class = new booksearch($error);

	if ($error)
	{
		trigger_error($error);
	}

	return $search_class;
}

?>